#include "lib.h"


/*****************************************************************************
 * memcpy, memset, and strlen
 *
 *   We must provide our own implementations of these basic functions!
 *   After all, we're writing the operating system ourselves.
 *
 *****************************************************************************/

void *
memcpy(void *dst, const void *src, size_t n)
{
	const char *s;
	char *d;
	int m;

	s = src;
	d = dst;
	m = n;
	while (--m >= 0)
		*d++ = *s++;

	return dst;
}

void *
memset(void *v, int c, size_t n)
{
	char *p;
	int m;

	p = v;
	m = n;
	while (--m >= 0)
		*p++ = c;

	return v;
}

int
strlen(const char *s)
{
	int l = 0;
	while (*s++)
		l++;
	return l;
}
